diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index a8dc1258a..cd535bb6d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -11,10 +11,12 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T> {
     private final boolean overrideRender;
+
     public BlockModelFire(Block<T> block) {
         this(block, false);
     }
@@ -25,17 +27,16 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockMetadata(x, y, z));
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockData(tilePos));
+        if (renderBlocks.overrideBlockTexture != null) {
             tex = renderBlocks.overrideBlockTexture;
         }
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, x, y, z)));
-        }else {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos)));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double uMin = tex.getIconUMin();
@@ -43,174 +44,171 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
         double vMin = tex.getIconVMin();
         double vMax = tex.getIconVMax();
         final float yOffset = 1.4F;
-        if(overrideRender || worldSource.isBlockNormalCube(x, y - 1, z) || BlockLogicFire.canBurn(worldSource, new TilePos(x, y - 1, z)) || worldSource == WorldClient.EMPTY_WORLD)
-        {
-            double d8 = (double)x + 0.5D + 0.2D;
-            double d9 = ((double)x + 0.5D) - 0.2D;
-            double d12 = (double)z + 0.5D + 0.2D;
-            double d14 = ((double)z + 0.5D) - 0.2D;
-            double d16 = ((double)x + 0.5D) - 0.3D;
-            double d18 = (double)x + 0.5D + 0.3D;
-            double d20 = ((double)z + 0.5D) - 0.3D;
-            double d22 = (double)z + 0.5D + 0.3D;
-            tessellator.addVertexWithUV(d16, (float)y + yOffset, z + 1, uMax, vMin);
+
+        TilePos queryPos = new TilePos();
+
+        int x = tilePos.x();
+        int y = tilePos.y();
+        int z = tilePos.z();
+
+        if (this.overrideRender || worldSource.isBlockNormalCube(tilePos.down(queryPos)) || BlockLogicFire.canBurn(worldSource, tilePos.down(queryPos)) || worldSource == WorldClient.EMPTY_WORLD) {
+            double d8 = (double) x + 0.5D + 0.2D;
+            double d9 = ((double) x + 0.5D) - 0.2D;
+            double d12 = (double) z + 0.5D + 0.2D;
+            double d14 = ((double) z + 0.5D) - 0.2D;
+            double d16 = ((double) x + 0.5D) - 0.3D;
+            double d18 = (double) x + 0.5D + 0.3D;
+            double d20 = ((double) z + 0.5D) - 0.3D;
+            double d22 = (double) z + 0.5D + 0.3D;
+            tessellator.addVertexWithUV(d16, (float) y + yOffset, z + 1, uMax, vMin);
             tessellator.addVertexWithUV(d8, y, z + 1, uMax, vMax);
             tessellator.addVertexWithUV(d8, y, z, uMin, vMax);
-            tessellator.addVertexWithUV(d16, (float)y + yOffset, z, uMin, vMin);
-            tessellator.addVertexWithUV(d18, (float)y + yOffset, z, uMax, vMin);
+            tessellator.addVertexWithUV(d16, (float) y + yOffset, z, uMin, vMin);
+            tessellator.addVertexWithUV(d18, (float) y + yOffset, z, uMax, vMin);
             tessellator.addVertexWithUV(d9, y, z, uMax, vMax);
             tessellator.addVertexWithUV(d9, y, z + 1, uMin, vMax);
-            tessellator.addVertexWithUV(d18, (float)y + yOffset, z + 1, uMin, vMin);
+            tessellator.addVertexWithUV(d18, (float) y + yOffset, z + 1, uMin, vMin);
             uMin = tex.getIconUMin();
             uMax = tex.getIconUMax();
             vMin = tex.getIconVMin();
             vMax = tex.getIconVMax(); //2x
-            tessellator.addVertexWithUV(x + 1, (float)y + yOffset, d22, uMax, vMin);
+            tessellator.addVertexWithUV(x + 1, (float) y + yOffset, d22, uMax, vMin);
             tessellator.addVertexWithUV(x + 1, y, d14, uMax, vMax);
             tessellator.addVertexWithUV(x, y, d14, uMin, vMax);
-            tessellator.addVertexWithUV(x, (float)y + yOffset, d22, uMin, vMin);
-            tessellator.addVertexWithUV(x, (float)y + yOffset, d20, uMax, vMin);
+            tessellator.addVertexWithUV(x, (float) y + yOffset, d22, uMin, vMin);
+            tessellator.addVertexWithUV(x, (float) y + yOffset, d20, uMax, vMin);
             tessellator.addVertexWithUV(x, y, d12, uMax, vMax);
             tessellator.addVertexWithUV(x + 1, y, d12, uMin, vMax);
-            tessellator.addVertexWithUV(x + 1, (float)y + yOffset, d20, uMin, vMin);
-            d8 = ((double)x + 0.5D) - 0.5D;
-            d9 = (double)x + 0.5D + 0.5D;
-            d12 = ((double)z + 0.5D) - 0.5D;
-            d14 = (double)z + 0.5D + 0.5D;
-            d16 = ((double)x + 0.5D) - 0.4D;
-            d18 = (double)x + 0.5D + 0.4D;
-            d20 = ((double)z + 0.5D) - 0.4D;
-            d22 = (double)z + 0.5D + 0.4D;
-            tessellator.addVertexWithUV(d16, (float)y + yOffset, z, uMin, vMin);
+            tessellator.addVertexWithUV(x + 1, (float) y + yOffset, d20, uMin, vMin);
+            d8 = ((double) x + 0.5D) - 0.5D;
+            d9 = (double) x + 0.5D + 0.5D;
+            d12 = ((double) z + 0.5D) - 0.5D;
+            d14 = (double) z + 0.5D + 0.5D;
+            d16 = ((double) x + 0.5D) - 0.4D;
+            d18 = (double) x + 0.5D + 0.4D;
+            d20 = ((double) z + 0.5D) - 0.4D;
+            d22 = (double) z + 0.5D + 0.4D;
+            tessellator.addVertexWithUV(d16, (float) y + yOffset, z, uMin, vMin);
             tessellator.addVertexWithUV(d8, y, z, uMin, vMax);
             tessellator.addVertexWithUV(d8, y, z + 1, uMax, vMax);
-            tessellator.addVertexWithUV(d16, (float)y + yOffset, z + 1, uMax, vMin);
-            tessellator.addVertexWithUV(d18, (float)y + yOffset, z + 1, uMin, vMin);
+            tessellator.addVertexWithUV(d16, (float) y + yOffset, z + 1, uMax, vMin);
+            tessellator.addVertexWithUV(d18, (float) y + yOffset, z + 1, uMin, vMin);
             tessellator.addVertexWithUV(d9, y, z + 1, uMin, vMax);
             tessellator.addVertexWithUV(d9, y, z, uMax, vMax);
-            tessellator.addVertexWithUV(d18, (float)y + yOffset, z, uMax, vMin);
+            tessellator.addVertexWithUV(d18, (float) y + yOffset, z, uMax, vMin);
             uMin = tex.getIconUMin();
             uMax = tex.getIconUMax();
             vMin = tex.getIconVMin();
             vMax = tex.getIconVMax();
-            tessellator.addVertexWithUV(x, (float)y + yOffset, d22, uMin, vMin);
+            tessellator.addVertexWithUV(x, (float) y + yOffset, d22, uMin, vMin);
             tessellator.addVertexWithUV(x, y, d14, uMin, vMax);
             tessellator.addVertexWithUV(x + 1, y, d14, uMax, vMax);
-            tessellator.addVertexWithUV(x + 1, (float)y + yOffset, d22, uMax, vMin);
-            tessellator.addVertexWithUV(x + 1, (float)y + yOffset, d20, uMin, vMin);
+            tessellator.addVertexWithUV(x + 1, (float) y + yOffset, d22, uMax, vMin);
+            tessellator.addVertexWithUV(x + 1, (float) y + yOffset, d20, uMin, vMin);
             tessellator.addVertexWithUV(x + 1, y, d12, uMin, vMax);
             tessellator.addVertexWithUV(x, y, d12, uMax, vMax);
-            tessellator.addVertexWithUV(x, (float)y + yOffset, d20, uMax, vMin);
-        } else
-        {
+            tessellator.addVertexWithUV(x, (float) y + yOffset, d20, uMax, vMin);
+        } else {
             float f3 = 0.2F;
             float f4 = 0.0625F;
-            if((x + y + z & 1) == 1)
-            {
+            if ((x + y + z & 1) == 1) {
                 uMin = tex.getIconUMin();
                 uMax = tex.getIconUMax();
                 vMin = tex.getIconVMin();
                 vMax = tex.getIconVMax(); // 2x
             }
-            if((x / 2 + y / 2 + z / 2 & 1) == 1)
-            {
+            if ((x / 2 + y / 2 + z / 2 & 1) == 1) {
                 double d10 = uMax;
                 uMax = uMin;
                 uMin = d10;
             }
-            if(BlockLogicFire.canBurn(worldSource, new TilePos(x - 1, y, z)))
-            {
-                tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMin, vMax);
-                tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z, uMin, vMin);
-                tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z, uMin, vMin);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMin, vMax);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, z + 1, uMax, vMax);
-                tessellator.addVertexWithUV((float)x + f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
+            if (BlockLogicFire.canBurn(worldSource, tilePos.west(queryPos))) {
+                tessellator.addVertexWithUV((float) x + f3, (float) y + yOffset + f4, z + 1, uMax, vMin);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, z + 1, uMax, vMax);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, z, uMin, vMax);
+                tessellator.addVertexWithUV((float) x + f3, (float) y + yOffset + f4, z, uMin, vMin);
+                tessellator.addVertexWithUV((float) x + f3, (float) y + yOffset + f4, z, uMin, vMin);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, z, uMin, vMax);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, z + 1, uMax, vMax);
+                tessellator.addVertexWithUV((float) x + f3, (float) y + yOffset + f4, z + 1, uMax, vMin);
             }
-            if(BlockLogicFire.canBurn(worldSource, new TilePos(x + 1, y, z)))
-            {
-                tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
-                tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
-                tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z + 1, uMax, vMax);
-                tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
-                tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z + 1, uMax, vMin);
-                tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z + 1, uMax, vMax);
-                tessellator.addVertexWithUV((x + 1), (float)(y) + f4, z, uMin, vMax);
-                tessellator.addVertexWithUV((float)(x + 1) - f3, (float)y + yOffset + f4, z, uMin, vMin);
+            if (BlockLogicFire.canBurn(worldSource, tilePos.east(queryPos))) {
+                tessellator.addVertexWithUV((float) (x + 1) - f3, (float) y + yOffset + f4, z, uMin, vMin);
+                tessellator.addVertexWithUV((x + 1), (float) (y) + f4, z, uMin, vMax);
+                tessellator.addVertexWithUV((x + 1), (float) (y) + f4, z + 1, uMax, vMax);
+                tessellator.addVertexWithUV((float) (x + 1) - f3, (float) y + yOffset + f4, z + 1, uMax, vMin);
+                tessellator.addVertexWithUV((float) (x + 1) - f3, (float) y + yOffset + f4, z + 1, uMax, vMin);
+                tessellator.addVertexWithUV((x + 1), (float) (y) + f4, z + 1, uMax, vMax);
+                tessellator.addVertexWithUV((x + 1), (float) (y) + f4, z, uMin, vMax);
+                tessellator.addVertexWithUV((float) (x + 1) - f3, (float) y + yOffset + f4, z, uMin, vMin);
             }
-            if(BlockLogicFire.canBurn(worldSource, new TilePos(x, y, z - 1)))
-            {
-                tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
-                tessellator.addVertexWithUV(x + 1, (float)(y) + f4, z, uMin, vMax);
-                tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)z + f3, uMin, vMin);
-                tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)z + f3, uMin, vMin);
-                tessellator.addVertexWithUV(x + 1, (float)(y) + f4, z, uMin, vMax);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, z, uMax, vMax);
-                tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)z + f3, uMax, vMin);
+            if (BlockLogicFire.canBurn(worldSource, tilePos.north(queryPos))) {
+                tessellator.addVertexWithUV(x, (float) y + yOffset + f4, (float) z + f3, uMax, vMin);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, z, uMax, vMax);
+                tessellator.addVertexWithUV(x + 1, (float) (y) + f4, z, uMin, vMax);
+                tessellator.addVertexWithUV(x + 1, (float) y + yOffset + f4, (float) z + f3, uMin, vMin);
+                tessellator.addVertexWithUV(x + 1, (float) y + yOffset + f4, (float) z + f3, uMin, vMin);
+                tessellator.addVertexWithUV(x + 1, (float) (y) + f4, z, uMin, vMax);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, z, uMax, vMax);
+                tessellator.addVertexWithUV(x, (float) y + yOffset + f4, (float) z + f3, uMax, vMin);
             }
-            if(BlockLogicFire.canBurn(worldSource, new TilePos(x, y, z + 1)))
-            {
-                tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
-                tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, (z + 1), uMax, vMax);
-                tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)(z + 1) - f3, uMax, vMin);
-                tessellator.addVertexWithUV(x, (float)y + yOffset + f4, (float)(z + 1) - f3, uMax, vMin);
-                tessellator.addVertexWithUV(x, (float)(y) + f4, (z + 1), uMax, vMax);
-                tessellator.addVertexWithUV(x + 1, (float)(y) + f4, (z + 1), uMin, vMax);
-                tessellator.addVertexWithUV(x + 1, (float)y + yOffset + f4, (float)(z + 1) - f3, uMin, vMin);
+            if (BlockLogicFire.canBurn(worldSource, tilePos.south(queryPos))) {
+                tessellator.addVertexWithUV(x + 1, (float) y + yOffset + f4, (float) (z + 1) - f3, uMin, vMin);
+                tessellator.addVertexWithUV(x + 1, (float) (y) + f4, (z + 1), uMin, vMax);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, (z + 1), uMax, vMax);
+                tessellator.addVertexWithUV(x, (float) y + yOffset + f4, (float) (z + 1) - f3, uMax, vMin);
+                tessellator.addVertexWithUV(x, (float) y + yOffset + f4, (float) (z + 1) - f3, uMax, vMin);
+                tessellator.addVertexWithUV(x, (float) (y) + f4, (z + 1), uMax, vMax);
+                tessellator.addVertexWithUV(x + 1, (float) (y) + f4, (z + 1), uMin, vMax);
+                tessellator.addVertexWithUV(x + 1, (float) y + yOffset + f4, (float) (z + 1) - f3, uMin, vMin);
             }
-            if(BlockLogicFire.canBurn(worldSource, new TilePos(x, y + 1, z)))
-            {
-                double d11 = (double)x + 0.5D + 0.5D;
-                double d13 = ((double)x + 0.5D) - 0.5D;
-                double d15 = (double)z + 0.5D + 0.5D;
-                double d17 = ((double)z + 0.5D) - 0.5D;
-                double d19 = ((double)x + 0.5D) - 0.5D;
-                double d21 = (double)x + 0.5D + 0.5D;
-                double d23 = ((double)z + 0.5D) - 0.5D;
-                double d24 = (double)z + 0.5D + 0.5D;
+            if (BlockLogicFire.canBurn(worldSource, tilePos.up(queryPos))) {
+                double d11 = (double) x + 0.5D + 0.5D;
+                double d13 = ((double) x + 0.5D) - 0.5D;
+                double d15 = (double) z + 0.5D + 0.5D;
+                double d17 = ((double) z + 0.5D) - 0.5D;
+                double d19 = ((double) x + 0.5D) - 0.5D;
+                double d21 = (double) x + 0.5D + 0.5D;
+                double d23 = ((double) z + 0.5D) - 0.5D;
+                double d24 = (double) z + 0.5D + 0.5D;
                 double d1 = tex.getIconUMin();
                 double d3 = tex.getIconUMax();
                 double d5 = tex.getIconVMin();
                 double d7 = tex.getIconVMax();
                 y++;
                 float f2 = -0.2F;
-                if((x + y + z & 1) == 0)
-                {
-                    tessellator.addVertexWithUV(d19, (float)y + f2, z, d3, d5);
+                if ((x + y + z & 1) == 0) {
+                    tessellator.addVertexWithUV(d19, (float) y + f2, z, d3, d5);
                     tessellator.addVertexWithUV(d11, y, z, d3, d7);
                     tessellator.addVertexWithUV(d11, y, z + 1, d1, d7);
-                    tessellator.addVertexWithUV(d19, (float)y + f2, z + 1, d1, d5);
+                    tessellator.addVertexWithUV(d19, (float) y + f2, z + 1, d1, d5);
                     d1 = tex.getIconUMin();
                     d3 = tex.getIconUMax();
                     d5 = tex.getIconVMin();
                     d7 = tex.getIconVMax();
-                    tessellator.addVertexWithUV(d21, (float)y + f2, z + 1, d3, d5);
+                    tessellator.addVertexWithUV(d21, (float) y + f2, z + 1, d3, d5);
                     tessellator.addVertexWithUV(d13, y, z + 1, d3, d7);
                     tessellator.addVertexWithUV(d13, y, z, d1, d7);
-                    tessellator.addVertexWithUV(d21, (float)y + f2, z, d1, d5);
-                } else
-                {
-                    tessellator.addVertexWithUV(x, (float)y + f2, d24, d3, d5);
+                    tessellator.addVertexWithUV(d21, (float) y + f2, z, d1, d5);
+                } else {
+                    tessellator.addVertexWithUV(x, (float) y + f2, d24, d3, d5);
                     tessellator.addVertexWithUV(x, y, d17, d3, d7);
                     tessellator.addVertexWithUV(x + 1, y, d17, d1, d7);
-                    tessellator.addVertexWithUV(x + 1, (float)y + f2, d24, d1, d5);
+                    tessellator.addVertexWithUV(x + 1, (float) y + f2, d24, d1, d5);
                     d1 = tex.getIconUMin();
                     d3 = tex.getIconUMax();
                     d5 = tex.getIconVMin();
                     d7 = tex.getIconVMax(); // 2x
-                    tessellator.addVertexWithUV(x + 1, (float)y + f2, d23, d3, d5);
+                    tessellator.addVertexWithUV(x + 1, (float) y + f2, d23, d3, d5);
                     tessellator.addVertexWithUV(x + 1, y, d15, d3, d7);
                     tessellator.addVertexWithUV(x, y, d15, d1, d7);
-                    tessellator.addVertexWithUV(x, (float)y + f2, d23, d1, d5);
+                    tessellator.addVertexWithUV(x, (float) y + f2, d23, d1, d5);
                 }
             }
         }
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
index 9c7e400f1..297cdc899 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFlowerStackable.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFlowerStackable;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFlowerStackable<T extends BlockLogicFlowerStackable> extends BlockModelCrossedSquares<T> {
@@ -13,19 +14,19 @@ public class BlockModelFlowerStackable<T extends BlockLogicFlowerStackable> exte
     public BlockModelFlowerStackable(Block<T> block, String baseTexture) {
         super(block);
 
-        ICONS = new IconCoordinate[T.MAX_STACK_COUNT + 1];
+        this.ICONS = new IconCoordinate[T.MAX_STACK_COUNT + 1];
         for (int i = 0; i < T.MAX_STACK_COUNT + 1; i++) {
-            ICONS[i] = TextureRegistry.getTexture(baseTexture + i);
+            this.ICONS[i] = TextureRegistry.getTexture(baseTexture + i);
         }
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         final int stackCount = T.getStackCount(data);
         if (stackCount > T.MAX_STACK_COUNT) {
-            return ICONS[0];
+            return this.ICONS[0];
         }
 
-        return ICONS[stackCount];
+        return this.ICONS[stackCount];
     }
 }
